<template>
  <v-form ref="form" v-model="valid" lazy-validation>
    <v-text-field
      v-model="paymentMethod.card.number"
      outlined
      required
      label="Card number"
      :rules="cardNumberRules"
    ></v-text-field>
    <v-text-field
      v-model="paymentMethod.card.name"
      outlined
      required
      label="Cardholder name"
      :rules="nameRules"
    ></v-text-field>

    <v-row>
      <v-col cols="3">
        <v-text-field
          v-model="paymentMethod.card.expiration.month"
          outlined
          required
          :rules="expirationMonthRules"
          placeholder="MM"
        ></v-text-field>
      </v-col>
      <v-col cols="3">
        <v-text-field
          v-model="paymentMethod.card.expiration.year"
          outlined
          required
          :rules="expirationYearRules"
          placeholder="YYYY"
        ></v-text-field>
      </v-col>
      <v-col cols="6">
        <v-text-field
          v-model="paymentMethod.card.crypto"
          outlined
          required
          label="Security code"
          :rules="cardCryptoRules"
        ></v-text-field>
      </v-col>
    </v-row>

    <v-btn @click="clear">Clear</v-btn>
    <v-btn color="primary" :disabled="!valid" @click="submit">Add</v-btn>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      valid: true,
      paymentMethod: {
        card: {
          number: '',
          name: '',
          crypto: '',
          expiration: {
            year: '',
            month: '',
          },
        },
      },
      nameRules: [(v: string) => !!v || 'Cardholder name is required'],
      cardNumberRules: [
        (v: string) => !!v || 'Card number is required',
        (v: string) =>
          /^[0-9]{15,16}$/.test(v) || 'Card number needs to be valid',
      ],
      expirationMonthRules: [
        (v: string) => !!v || 'Expiration is required',
        (v: string) =>
          /^((0?[1-9]{1})|(1[0-2]))$/.test(v) ||
          'Expiration month must be valid',
      ],
      expirationYearRules: [
        (v: string) => !!v || 'Expiration is required',
        (v: string) =>
          /^20[2-9][1-9]$/.test(v) || 'Expiration year must be valid',
      ],
      cardCryptoRules: [
        (v: string) => !!v || 'Security code is required',
        (v: string) => /^[0-9]{3,4}$/.test(v) || 'Security code must be valid',
      ],
    }
  },
  methods: {
    clear(): void {
      ;(this.$refs.form as any).reset()
    },
    submit(): void {
      if ((this.$refs.form as any).validate()) {
        this.$axios.$post('http://consumer.localhost:4000/wallets', {
          ...this.paymentMethod,
          method: 'credit_card',
          owner: this.$store.state.loggedIn, // ! current logged user ID
          ownerType: 'consumer',
        })

        this.$router.push('/account/wallet')
      }
    },
  },
})
</script>
